/*************************************************************************/
/* Global parameters for Tree2                                           */
/*************************************************************************/


extern  int		MAXDEPTH;       /* maximum depth of the tree, 0..2 */

extern  Boolean		UNSEENS;	/* true if to evaluate on test data */


/***********************/
/* Global ContinArrays */
/***********************/

extern  ItemCount       *Error_L, *Error_U;
                           /* Error_L,Error_U[0..MaxItem],
			      contains the number of errors of the best split at Item[i]
			         found until now. */

extern  Attribute       *Att_L, *Att_U;
                           /* Att_l,Att_U[0..MaxItem],
			      the best attributes to select after spliting on Item[i]. */

extern  IntervalSplit   *IntSpl_L, *IntSpl_U;
                           /* IntSpl_L,IntSpl_U[0..MacItem],
			      If Att_L[i] resp. Att_U[i] is a continuous attribute,
			         IntSpl_L[i] resp. IntSpl_U[i] contains the optimal split on 
			         attribute Att_L[i] resp. Att_U[i] */

extern  ItemCount       *Freq_L, *Freq_U;   
                           /* Freq_L,Freq_U[0..MaxClass], just used for calculations */



/***************************/
/* Frequency global arrays */
/***************************/


extern  ClassNo         BEST_ALL, *BEST;   
                           /* BEST[0..MaxDiscrVal]
			      BEST[v] is the best class for attribute value v,
			      BEST_ALL is the overall best class */
			      
extern  ItemCount       FREQ_ALL, ERROR_ALL, *FREQ, *ERROR;
                           /* FREQ[v] is the number of items with attribute value v,
			      ERROR[v] is the number of items incorrectly classified 
			         by BEST[v],
			      FREQ_ALL is the total number of items,
			      ERROR_ALL is the number of items incorrectly classified 
                                 by BEST_ALL */
				 
extern  ItemCount       *_FreqA, **_Freq;
                           /* Used by InitFreq to calculate the above quantities,
 			         _FreqA[0..MaxClass], _Freq[0..MaxClass][0..MaxDiscrVal],
			         _TotalFreq[0..MaxDiscrVal].
		              Also used by SecondSplitDiscr */

extern  ItemCount       **_Freq_L;
                           /* Freq_L[0..MaxClass][0..MaxDiscrVal],
			      used by SecondSplitDiscr together with _Freq. */ 

			      
			      
/**********************************/
/* Global dynamic data structures */
/**********************************/


extern AllList          LIST_ALRecord;
extern ItemList         LIST_ILRecord;
extern SuperList        LIST_SLRecord;


extern float Infinity;

























