/**********************/
/* Main routine of T2 */
/**********************/

#include "header.i"
#include "global.i"
		
int main(Argc, Argv)
/*  ----  */
    int Argc;
    char *Argv[];
{
    Tree Root;
    ItemNo i;


    PrintHeader();

    CommandInput(Argc,Argv);

    GetNames();
    GetData(".data");
    printf("\nRead %d cases (%d attributes) from %s.data\n",
	   MaxItem+1, MaxAtt+1, FileName);
    for(i=0; i <= MaxItem; i++) Weight(Item[i]) = 1.0;

    if( MAXINTERVALS < 1 ) MAXINTERVALS = MaxClass+2;
    printf("\tNumber of intervals is %d\n", MAXINTERVALS);
	   
    InitializeData();

    Root = BuildTree(0, MaxItem, MAXDEPTH, None);
    PrintTree(Root);

    printf("\n\nEvaluation on training data (%d items):\n", MaxItem+1);
    Evaluate(Root);

    if ( UNSEENS )
    {   
        GetData(".test");
        for(i=0; i <= MaxItem; i++) Weight(Item[i]) = 1.0;
        printf("\nEvaluation on test data (%d items):\n", MaxItem+1);
        Evaluate(Root);
    }
    printf("\n");
    
    return 0;
}

